local arrayOfElements = {}
local L = WeekKeys.L
local WeekFrame = WeekKeys.WeekFrame

local loot_btns = {}
local hide_frames = {}
local tabl = {}
local mythic_level = {
    nil, -- index 1 -> mythic 1?
    6808,-- index 2 -> mythic 2
    6809,
    7203,
    7204,
    7205,
    7206,
    7207,
    7208,
    7209,
    7210,
    7211,
    7212,
    7213,
    7214
}
local end_of_run_ilvl = {
    nil,
    5845,
    5848,
    5852,
    5852,
    5852,
    5858,
    5858,
    5858,
    5861,
    5861,
    5865,
    5865,
    5865,
    5868
}

local function createmyclasslist(btn)
    -- background for class buttons
    local back = CreateFrame("Frame",nil,btn,"InsetFrameTemplate")
    back:SetPoint("BOTTOMLEFT",0,30)
    local btnsize = 30
    back:SetSize(btnsize * 4 + 20, btnsize * 3 + 20) -- change to setpoint
    -- class buttons with onclick script
    for i = 1, 12 do
        local button = WeekKeys.UI.Button(nil, back)
        button:SetPoint("TOPLEFT",(i-1)%4*btnsize+10,-1*math.floor((i-1)/4)*btnsize-10)
        button:SetSize(btnsize,btnsize)
        button:SetID(i)
        local _, class, _ = GetClassInfo(i)
        button.texture:SetTexture("Interface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES")
        local coords = CLASS_ICON_TCOORDS[class]
        button.texture:SetTexCoord(unpack(coords))

        button:SetScript("onclick",function(self)
            LootFinder.class = self:GetID()
            LootFinder.spec = 0
            -- specrefresh()
            btn.texture:SetTexture(self.texture:GetTexture())
            local _, class, _ = GetClassInfo(self:GetID())
            local coords = CLASS_ICON_TCOORDS[class]
            btn.texture:SetTexCoord(unpack(coords))
            back:Hide()
            LootFinder:Find()
        end)
    end
    hide_frames[#hide_frames + 1] = back
  --  back:SetScript("OnLeave",function(self) self:Hide() end)
    back:Hide()
    return back
end

local function createspeclist(btn)
    local spec_btn_list = {}
    -- background for spec buttons
    local back = CreateFrame("Frame",nil,btn,"InsetFrameTemplate")
    back:SetPoint("BOTTOMLEFT",0,30)
    local btnsize = 30
    back:SetSize(btnsize * 3 + 20, btnsize * 2 + 20) -- change to setpoint
    for i = 1, 5 do
        local button = WeekKeys.UI.Button(nil, back)
        button:SetPoint("TOPLEFT",(i-1)%3*btnsize+2,-1*math.floor((i-1)/3)*btnsize-2)
        button:SetSize(btnsize,btnsize)
        button:SetScript("OnClick",function(self)
            LootFinder.spec = self:GetID()
            btn.texture:SetTexture(self.texture:GetTexture())
            back:Hide()
            LootFinder:Find()
        end)
        spec_btn_list[i] = button
    end

    back:SetScript("OnShow",function(self) 
        local len = #LootFinder.class_spec[LootFinder.class] 
        if len == 0 then self:Hide() end -- hide if no class choosen
        local spec_ids = LootFinder.class_spec[LootFinder.class]
        if len == 2 then back:SetSize(btnsize * 3 + 10, btnsize * 1 + 10) else back:SetSize(btnsize * 3 + 10, btnsize * 2 + 10) end
        for i = 1, len do
           local _, _, _, icon, _, _ = GetSpecializationInfoByID(spec_ids[i])
           spec_btn_list[i]:SetID(spec_ids[i])
           spec_btn_list[i].texture:SetTexture(icon)
           spec_btn_list[i]:Show()
        end
        spec_btn_list[len+1]:SetID(0)
        spec_btn_list[len+1].texture:SetTexture(QUESTION_MARK_ICON)
        spec_btn_list[len+1]:Show()
        for i = len + 2, 5 do
            spec_btn_list[i]:Hide()
        end
    end)
    hide_frames[#hide_frames + 1] = back
    --back:SetScript("OnLeave",function(self) self:Hide() end)
    back:Hide()
    return back
end

local function createslotlist(btn)
    -- background for spec buttons
    local back = CreateFrame("Frame",nil,btn,"InsetFrameTemplate")
    back:SetPoint("BOTTOMLEFT",0,30)
    local btnsize = 30
    back:SetSize(btnsize * 4 + 20, btnsize * 4 + 20) -- change to setpoint
    local icons = {133070,133292,135061,133771,132751,132616,132939,132511,134584,132535,135317,134959,801523,133441,QUESTION_MARK_ICON}
    local slots = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,15}

    for i = 1, #icons do 
        local button = WeekKeys.UI.Button(nil, back)
        button:SetPoint("TOPLEFT",(i-1)%4*btnsize+10,-1*math.floor((i-1)/4)*btnsize-10)
        button:SetSize(btnsize,btnsize)
        button.texture:SetTexture(icons[i])
        button:SetID(slots[i])
        button:SetScript("OnClick",function(self)
            LootFinder.slot = self:GetID()
            btn.texture:SetTexture(self.texture:GetTexture())
            back:Hide()
            LootFinder:Find()
        end)
    end
    hide_frames[#hide_frames + 1] = back
    --back:SetScript("OnLeave",function(self) self:Hide() end)
    back:Hide()
    return back
end
-- instances
local function createinstancelist(btn)
    -- background for instance buttons
    local back = CreateFrame("Frame",nil,btn,"InsetFrameTemplate")
    back:SetPoint("BOTTOMLEFT",0,30)
    local btnsize = 30
    back:SetSize(btnsize * 4 + 20, btnsize * 4 + 20) -- change to setpoint

    local i = 1
    EJ_SelectTier(LootFinder.expansion)
    while EJ_GetInstanceByIndex(i, false) ~= nil do
        LootFinder.instances[i] = true
        local _, name, _, bgim, buttonImage1, loreImage, buttonImage2 = EJ_GetInstanceByIndex(i, false)
        local button = WeekKeys.UI.Button(nil, back)
        --button.texture:SetColorTexture(0,0,0,0)
        button.name = name
        button:SetPoint("TOPLEFT",(i-1)%4*btnsize+10,-1*math.floor((i-1)/4)*btnsize-10)
        button:SetSize(btnsize,btnsize)
        button:SetID(i)
        button.texture:SetTexture(buttonImage2)
        button.find = true
        function button:enable(bool)
            if bool then
                LootFinder.instances[self:GetID()] = true
                self.texture:SetAlpha(1)
            else
                LootFinder.instances[self:GetID()] = false
                self.texture:SetAlpha(0.3)
            end
            self.find = bool
        end
        button:SetScript("OnClick",function(self)
            self:enable(not self.find)
            LootFinder:Find()
        end)
        button:SetScript("OnEnter",function(self)
            GameTooltip:Hide();
            GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
            GameTooltip:AddLine(self.name)
            GameTooltip:Show()
        end)
        button:SetScript("OnLeave",function()
            GameTooltip:Hide();
        end)
        i = i + 1
    end
    back:SetHeight(math.floor((i-1)/4)*btnsize+20)

    hide_frames[#hide_frames + 1] = back
    --back:SetScript("OnLeave",function(self) self:Hide() end)
    back:Hide()
    return back
end

local function setunfind(...)
    local _, arg1,arg2 = ...
    if arg2 == 0 then
        if arg1 == "ITEM_MOD_STRENGTH_SHORT" then
            UIDropDownMenu_SetText(Stating3,SPEC_FRAME_PRIMARY_STAT_STRENGTH)
        elseif arg1 == "ITEM_MOD_AGILITY_SHORT" then
            UIDropDownMenu_SetText(Stating3,SPEC_FRAME_PRIMARY_STAT_AGILITY)
        elseif arg1 == "ITEM_MOD_INTELLECT_SHORT" then
            UIDropDownMenu_SetText(Stating3,SPEC_FRAME_PRIMARY_STAT_INTELLECT)
        elseif arg1 == "ITEM_MOD_CRIT_RATING_SHORT" then
            UIDropDownMenu_SetText(Stating3,STAT_CRITICAL_STRIKE)
        elseif arg1 == "ITEM_MOD_HASTE_RATING_SHORT" then
            UIDropDownMenu_SetText(Stating3,STAT_HASTE)
        elseif arg1 == "ITEM_MOD_VERSATILITY" then
            UIDropDownMenu_SetText(Stating3,STAT_VERSATILITY)
        elseif arg1 == "ITEM_MOD_MASTERY_RATING_SHORT" then
            UIDropDownMenu_SetText(Stating3,STAT_MASTERY)
        else
            UIDropDownMenu_SetText(Stating3,"-------")
        end
        LootFinder.stat1 = arg1
    elseif arg1 == 0 then
        if arg2 == "ITEM_MOD_STRENGTH_SHORT" then
            UIDropDownMenu_SetText(Stating4,SPEC_FRAME_PRIMARY_STAT_STRENGTH)
        elseif arg2 == "ITEM_MOD_AGILITY_SHORT" then
            UIDropDownMenu_SetText(Stating4,SPEC_FRAME_PRIMARY_STAT_AGILITY)
        elseif arg2 == "ITEM_MOD_INTELLECT_SHORT" then
            UIDropDownMenu_SetText(Stating4,SPEC_FRAME_PRIMARY_STAT_INTELLECT)
        elseif arg2 == "ITEM_MOD_CRIT_RATING_SHORT" then
            UIDropDownMenu_SetText(Stating4,STAT_CRITICAL_STRIKE)
        elseif arg2 == "ITEM_MOD_HASTE_RATING_SHORT" then
            UIDropDownMenu_SetText(Stating4,STAT_HASTE)
        elseif arg2 == "ITEM_MOD_VERSATILITY" then
            UIDropDownMenu_SetText(Stating4,STAT_VERSATILITY)
        elseif arg2 == "ITEM_MOD_MASTERY_RATING_SHORT" then
            UIDropDownMenu_SetText(Stating4,STAT_MASTERY)
        else
            UIDropDownMenu_SetText(Stating4,"-------")
        end
        LootFinder.stat2 = arg2
    end
    LootFinder:Find()
  --  print(...)
    
end
-- stat choose (later replace this)
---[[
function WeekKeys.WPDropDownDemo_Menu1(frame, level, menuList)
    local info = UIDropDownMenu_CreateInfo()
    info.text = OPTIONAL
    info.arg2 = 0
    info.func = setunfind
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = SPEC_FRAME_PRIMARY_STAT_STRENGTH,"ITEM_MOD_STRENGTH_SHORT","ITEM_MOD_STRENGTH_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = SPEC_FRAME_PRIMARY_STAT_AGILITY,"ITEM_MOD_AGILITY_SHORT", "ITEM_MOD_AGILITY_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = SPEC_FRAME_PRIMARY_STAT_INTELLECT,"ITEM_MOD_INTELLECT_SHORT", "ITEM_MOD_INTELLECT_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = STAT_CRITICAL_STRIKE,"ITEM_MOD_CRIT_RATING_SHORT", "ITEM_MOD_CRIT_RATING_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = STAT_HASTE,"ITEM_MOD_HASTE_RATING_SHORT", "ITEM_MOD_HASTE_RATING_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = STAT_VERSATILITY,"ITEM_MOD_VERSATILITY", "ITEM_MOD_VERSATILITY" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = STAT_MASTERY,"ITEM_MOD_MASTERY_RATING_SHORT", "ITEM_MOD_MASTERY_RATING_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
end

function WeekKeys.WPDropDownDemo_Menu2(frame, level, menuList)
    local info = UIDropDownMenu_CreateInfo()
    info.text = OPTIONAL
    info.arg1 = 0
    info.func = setunfind
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = SPEC_FRAME_PRIMARY_STAT_STRENGTH,"ITEM_MOD_STRENGTH_SHORT", "ITEM_MOD_STRENGTH_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = SPEC_FRAME_PRIMARY_STAT_AGILITY,"ITEM_MOD_AGILITY_SHORT", "ITEM_MOD_AGILITY_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = SPEC_FRAME_PRIMARY_STAT_INTELLECT,"ITEM_MOD_INTELLECT_SHORT", "ITEM_MOD_INTELLECT_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = STAT_CRITICAL_STRIKE,"ITEM_MOD_CRIT_RATING_SHORT", "ITEM_MOD_CRIT_RATING_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = STAT_HASTE,"ITEM_MOD_HASTE_RATING_SHORT", "ITEM_MOD_HASTE_RATING_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = STAT_VERSATILITY,"ITEM_MOD_VERSATILITY", "ITEM_MOD_VERSATILITY" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = STAT_MASTERY,"ITEM_MOD_MASTERY_RATING_SHORT", "ITEM_MOD_MASTERY_RATING_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
end
--]]

--mylist = nil
WeekKeys.AddInit(function()
    arrayOfElements[1] = CreateFrame('Frame')
   -- mylist = arrayOfElements[1]
    arrayOfElements[1]:SetFrameStrata("BACKGROUND")
    arrayOfElements[1]:SetSize(10,10)
    arrayOfElements[1]:SetScript("OnShow",function()
        WeekKeys.WeekFrame.ScrollFrame:ClearAllPoints()
        WeekKeys.WeekFrame.ScrollFrame:SetPoint("TOPLEFT", WeekKeys.WeekFrame, "TOPLEFT", 4, -80);
        WeekKeys.WeekFrame.ScrollFrame:SetPoint("BOTTOMRIGHT", WeekKeys.WeekFrame, "BOTTOMRIGHT", -5, 5);
    end)
    arrayOfElements[1]:Hide()

    -- class btn
    local class_btn = WeekKeys.UI.Button(nil, WeekKeys.WeekFrame)
    class_btn:SetSize(30,30)
    class_btn:SetPoint("TopLeft",20,-30)
    class_btn.texture:SetTexture(QUESTION_MARK_ICON)
    class_btn:SetScript("OnClick",function(self) 
        self.showframe = self.showframe or createmyclasslist(self)
        if self.showframe:IsShown() then
            return self.showframe:Hide()  
        end
        for _,v in pairs(hide_frames) do v:Hide() end
        self.showframe:Show()
    end)
    class_btn:Hide()
    arrayOfElements[2] = class_btn

    -- spec btn
    local spec_btn = WeekKeys.UI.Button(nil, WeekKeys.WeekFrame)
    spec_btn:SetSize(30,30)
    spec_btn:SetPoint("Topleft",60,-30)
    spec_btn.texture:SetTexture(QUESTION_MARK_ICON)
    spec_btn:SetScript("OnClick",function(self)
        self.showframe = self.showframe or createspeclist(self) 
        if self.showframe:IsShown() then
            return self.showframe:Hide()
        end
        for _,v in pairs(hide_frames) do v:Hide() end
        self.showframe:Show()
    end)
    spec_btn:Hide()
    arrayOfElements[3] = spec_btn

    -- slot btn
    local slot_btn = WeekKeys.UI.Button(nil, WeekKeys.WeekFrame)
    slot_btn:SetSize(30,30)
    slot_btn:SetPoint("Topleft",100,-30)
    slot_btn.texture:SetTexture(QUESTION_MARK_ICON)
    slot_btn:SetScript("OnClick",function(self)
        self.showframe = self.showframe or createslotlist(self)
        if self.showframe:IsShown() then
            return self.showframe:Hide()
        end
        for _,v in pairs(hide_frames) do v:Hide() end
        self.showframe:Show()
    end)
    slot_btn:Hide()
    arrayOfElements[4] = slot_btn

    -- instances
    local instance_btn = WeekKeys.UI.Button(nil, WeekKeys.WeekFrame)
    instance_btn:SetSize(30,30)
    instance_btn:SetPoint("Topleft",140,-30)
    instance_btn.texture:SetTexture(QUESTION_MARK_ICON)
    instance_btn:SetScript("OnClick",function(self)
        self.showframe = self.showframe or createinstancelist(self)
        if self.showframe:IsShown() then
            return self.showframe:Hide()
        end
        for _,v in pairs(hide_frames) do v:Hide() end
        self.showframe:Show()
    end)
    instance_btn:Hide()
    arrayOfElements[5] = instance_btn

    -- keylevel
    local keylevel_editbox = CreateFrame("EditBox",nil,WeekKeys.WeekFrame,"InputBoxTemplate")
    keylevel_editbox:SetAutoFocus(false)
    keylevel_editbox:SetPoint("TOPLEFT",180,-30)
    keylevel_editbox:SetSize(50,20)
    keylevel_editbox:SetNumber(15)
    keylevel_editbox:ClearFocus()
    keylevel_editbox:SetMaxLetters(2)
    keylevel_editbox:SetNumeric(true)

    keylevel_editbox:SetScript("OnEditFocusLost",function(self)
        LootFinder.level = max(self:GetNumber(), 2)
        C_EncounterJournal.SetPreviewMythicPlusLevel(LootFinder.level)
        self:ClearFocus()
        LootFinder:Find()
    end)

    keylevel_editbox:SetScript("OnEnterPressed",function(self)
        self:ClearFocus()
        LootFinder:Find()
    end)

    keylevel_editbox:SetScript("OnShow",function()
        C_EncounterJournal.SetPreviewMythicPlusLevel(LootFinder.level)
        LootFinder:Find()
    end)
    keylevel_editbox:SetScript("OnHide",function()
        C_EncounterJournal.SetPreviewMythicPlusLevel(0)
        LootFinder:Find()
    end)

    keylevel_editbox:Hide()
    arrayOfElements[6] = keylevel_editbox
    -- filters
    ---[[
    local stat1_choose = CreateFrame("Frame", "Stating3", WeekKeys.WeekFrame, "UIDropDownMenuTemplate")
    stat1_choose:SetPoint("TOPLEFT",240,-30)
    UIDropDownMenu_SetWidth(stat1_choose, 100)
    UIDropDownMenu_Initialize(stat1_choose, WeekKeys.WPDropDownDemo_Menu1)
    UIDropDownMenu_SetText(stat1_choose,OPTIONAL)
    stat1_choose:Hide()
    arrayOfElements[7] = stat1_choose

    local stat2_choose = CreateFrame("Frame", "Stating4", WeekKeys.WeekFrame, "UIDropDownMenuTemplate")
    stat2_choose:SetPoint("TOPLEFT",350,-30)
    UIDropDownMenu_SetWidth(stat2_choose, 100)
    UIDropDownMenu_Initialize(stat2_choose, WeekKeys.WPDropDownDemo_Menu2)
    UIDropDownMenu_SetText(stat2_choose,OPTIONAL)
    stat2_choose:Hide()
    arrayOfElements[8] = stat2_choose
--]]
    -- "dungeons"
    local label = WeekKeys.WeekFrame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
    label:SetPoint("TOPLEFT",25,-60)
    label:SetSize(200,20)
    label:SetText(DUNGEONS)
    label:Hide()
    arrayOfElements[9] = label
    -- list of globalstrings dungeon/instance 
    -- CALENDAR_TYPE_DUNGEON 
    -- INSTANCE_CHAT
    -- INSTANCE_CHAT_MESSAGE 
    -- ENCOUNTER_JOURNAL_INSTANCE 
    -- DUNGEONS 
    -- INSTANCE 
    -- CHAT_MSG_INSTANCE_CHAT 
    -- GUILD_CHALLENGE_TYPE1 
    -- GUILD_INTEREST_DUNGEON 
    -- VOICE_CHANNEL_NAME_INSTANCE 
    -- LFG_TYPE_DUNGEON 

    local label = WeekKeys.WeekFrame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
    label:SetPoint("TOPLEFT",230,-60)
    label:SetSize(50,20)
    label:SetFormattedText(SPEC_FRAME_PRIMARY_STAT,"")
    label:Hide()
    arrayOfElements[10] = label

    local label = WeekKeys.WeekFrame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
    label:SetPoint("TOPLEFT",280,-60)
    label:SetSize(50,20)
    label:SetText(SPELL_CRIT_CHANCE)
    label:Hide()
    arrayOfElements[11] = label

    local label = WeekKeys.WeekFrame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
    label:SetPoint("TOPLEFT",330,-60)
    label:SetSize(50,20)
    label:SetText(STAT_HASTE)
    label:Hide()
    arrayOfElements[12] = label

    local label = WeekKeys.WeekFrame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
    label:SetPoint("TOPLEFT",380,-60)
    label:SetSize(50,20)
    label:SetText(STAT_MASTERY)
    label:Hide()
    arrayOfElements[13] = label

    local label = WeekKeys.WeekFrame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
    label:SetPoint("TOPLEFT",430,-60)
    label:SetSize(50,20)
    label:SetText(STAT_VERSATILITY)
    label:Hide()
    arrayOfElements[14] = label

--[[
    btn.name = btn:CreateFontString(nil, "ARTWORK", "GameFontNormal")
    btn.name:SetPoint("TOPLEFT",20,0)
    btn.name:SetSize(160,height)
    btn.name:SetJustifyH("TOPLEFT")
    10 -> 230
    11 -> 280
    12 -> 330
    13 -> 380
    14 -> 430
    --]]
    -- result printing
    hooksecurefunc(LootFinder, "Find", function()  -- yes, I hook my function :D
       -- DevTools_Dump(LootFinder.LootList)
        for i = #loot_btns, #LootFinder.LootList do -- loop to create new buttons, when lootcount > buttoncount
            local btn = WeekKeys.UI.Button(nil, arrayOfElements[1])
            loot_btns[#loot_btns + 1] = btn
            btn:SetSize(WeekKeys.WeekFrame:GetWidth()-8,20)
            btn:SetPoint("TOPLEFT",4,-(i)*20)

            btn.icon = btn:CreateTexture('textureName', 'CENTER')
            btn.icon:SetPoint("LEFT",5,0)
            btn.icon:SetSize(18,18)
            --btn.icon:SetPoint('TOPLEFT', 22, 0)

            -- dungeon
            btn.instance = btn:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            btn.instance:SetPoint("LEFT",25,0)
            btn.instance:SetSize(200,20)
            btn.instance:SetJustifyH("LEFT")

            -- main atr
            btn.mainatr = btn:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            btn.mainatr:SetPoint("LEFT",230,0)
            btn.mainatr:SetSize(50,20)

            -- crit
            btn.crit = btn:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            btn.crit:SetPoint("LEFT",280,0)
            btn.crit:SetSize(50,20)

            -- haste
            btn.haste = btn:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            btn.haste:SetPoint("LEFT",330,0)
            btn.haste:SetSize(50,20)

            -- mastery
            btn.mastery = btn:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            btn.mastery:SetPoint("LEFT",380,0)
            btn.mastery:SetSize(50,20)

            -- vers
            btn.versality = btn:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            btn.versality:SetPoint("LEFT",430,0)
            btn.versality:SetSize(50,20)

            btn.setdata = function(self,dungeon,itemlink)
                local pattern = "5:"..mythic_level[LootFinder.level]..":6652:1501:"..end_of_run_ilvl[LootFinder.level]..":6646"
                itemlink = itemlink:gsub("%d+:3524:%d+:%d+:%d+:","5:"..mythic_level[LootFinder.level]..":6652:1501:"..end_of_run_ilvl[LootFinder.level]..":6646")
                GetItemStats(itemlink,wipe(tabl or {}))
                -- texture
                local _, _, _, _, icon = GetItemInfoInstant(itemlink)
                self.icon:SetTexture(icon)

                -- dungeon
                self.instance:SetText(dungeon or "")

                -- atr
                self.mainatr:SetText(tabl.ITEM_MOD_STRENGTH_SHORT or tabl.ITEM_MOD_AGILITY_SHORT or tabl.ITEM_MOD_INTELLECT_SHORT or 0)
                self.crit:SetText(tabl.ITEM_MOD_CRIT_RATING_SHORT or 0)
                self.haste:SetText(tabl.ITEM_MOD_HASTE_RATING_SHORT or 0)
                self.mastery:SetText(tabl.ITEM_MOD_MASTERY_RATING_SHORT or 0)
                self.versality:SetText(tabl.ITEM_MOD_VERSATILITY or 0)

                self.itemlink = itemlink
            end
            btn:SetScript("OnEnter",function(self)
                GameTooltip:Hide()
                GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
                GameTooltip:SetHyperlink(self.itemlink)
                GameTooltip:Show()
            end)
            btn:SetScript("OnLeave",function(self)
                GameTooltip:Hide()
            end)

        end
        for i = 1, #loot_btns do -- hide all buttons for situation when buttoncoutn > lootcount
            loot_btns[i]:Hide()
        end
        for index,val in pairs(LootFinder.LootList)  do -- show and set information (self,dungeon,itemlink)
            loot_btns[index]:setdata(val[1],val[2])
            loot_btns[index]:Show()
        end
    end)

    WeekKeys.AddButton(L["lootfinder"],arrayOfElements)
end)


--[[
local arrayOfElements = {}


WeekKeys.AddInit(function()
local L = WeekKeys.L
local WeekFrame = WeekKeys.WeekFrame
WeekFrame.ClassBtn = {}
WeekFrame.SpecBtn = {}
WeekFrame.SlotBtn = {}
WeekFrame.LootBtn = {}

local mythic_level = {
    nil, -- index 1 -> mythic 1?
    6808,-- index 2 -> mythic 2
    6809,
    7203,
    7204,
    7205,
    7206,
    7207,
    7208,
    7209,
    7210,
    7211,
    7212,
    7213,
    7214
}

local end_of_run_ilvl = {
    nil,
    5845,
    5848,
    5852,
    5852,
    5852,
    5858,
    5858,
    5858,
    5861,
    5861,
    5865,
    5865,
    5865,
    5868
}

function WeekFrame.WPDropDownDemo_Menu1(frame, level, menuList)
    local info = UIDropDownMenu_CreateInfo()
    info.text = OPTIONAL
    info.arg2 = 0
    info.func = LootFinder.SetStat
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = SPEC_FRAME_PRIMARY_STAT_STRENGTH,"ITEM_MOD_STRENGTH_SHORT","ITEM_MOD_STRENGTH_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = SPEC_FRAME_PRIMARY_STAT_AGILITY,"ITEM_MOD_AGILITY_SHORT", "ITEM_MOD_AGILITY_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = SPEC_FRAME_PRIMARY_STAT_INTELLECT,"ITEM_MOD_INTELLECT_SHORT", "ITEM_MOD_INTELLECT_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = STAT_CRITICAL_STRIKE,"ITEM_MOD_CRIT_RATING_SHORT", "ITEM_MOD_CRIT_RATING_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = STAT_HASTE,"ITEM_MOD_HASTE_RATING_SHORT", "ITEM_MOD_HASTE_RATING_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = STAT_VERSATILITY,"ITEM_MOD_VERSATILITY", "ITEM_MOD_VERSATILITY" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = STAT_MASTERY,"ITEM_MOD_MASTERY_RATING_SHORT", "ITEM_MOD_MASTERY_RATING_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
end

function WeekFrame.WPDropDownDemo_Menu2(frame, level, menuList)
    local info = UIDropDownMenu_CreateInfo()
    info.text = OPTIONAL
    info.arg1 = 0
    info.func = LootFinder.SetStat
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = SPEC_FRAME_PRIMARY_STAT_STRENGTH,"ITEM_MOD_STRENGTH_SHORT", "ITEM_MOD_STRENGTH_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = SPEC_FRAME_PRIMARY_STAT_AGILITY,"ITEM_MOD_AGILITY_SHORT", "ITEM_MOD_AGILITY_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = SPEC_FRAME_PRIMARY_STAT_INTELLECT,"ITEM_MOD_INTELLECT_SHORT", "ITEM_MOD_INTELLECT_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = STAT_CRITICAL_STRIKE,"ITEM_MOD_CRIT_RATING_SHORT", "ITEM_MOD_CRIT_RATING_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = STAT_HASTE,"ITEM_MOD_HASTE_RATING_SHORT", "ITEM_MOD_HASTE_RATING_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = STAT_VERSATILITY,"ITEM_MOD_VERSATILITY", "ITEM_MOD_VERSATILITY" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = STAT_MASTERY,"ITEM_MOD_MASTERY_RATING_SHORT", "ITEM_MOD_MASTERY_RATING_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
end

arrayOfElements[1] = CreateFrame('Frame')
arrayOfElements[1]:SetFrameStrata("BACKGROUND")
arrayOfElements[1]:SetSize(10,10)
arrayOfElements[1]:SetScript("OnShow",function()
    WeekFrame.ScrollFrame:ClearAllPoints()
    WeekFrame.ScrollFrame:SetPoint("TOPLEFT", WeekFrame, "TOPLEFT", 4, -300);
    WeekFrame.ScrollFrame:SetPoint("BOTTOMRIGHT", WeekFrame, "BOTTOMRIGHT", -5, 5);
end)
arrayOfElements[1]:Hide()
for i = 1, 12 do
    arrayOfElements[i+1] = CreateFrame("button",nil,WeekFrame)
    arrayOfElements[i+1]:SetPoint("TOPLEFT",0+i*35,-35)
    arrayOfElements[i+1]:SetSize(35,35)
    arrayOfElements[i+1]:SetID(i)
    arrayOfElements[i+1].icon = arrayOfElements[i+1]:CreateTexture(nil,"BACKGROUND"); -- create texture as child of myframe
    arrayOfElements[i+1].icon:SetAllPoints(arrayOfElements[i+1]); -- copy dimensions of myframe to icon
    local _, class, _ = GetClassInfo(i)
   -- local _,class = UnitClass("player"); -- get non-localized class name
    arrayOfElements[i+1].icon:SetTexture("Interface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES"); -- this is the image containing all class icons
    local coords = CLASS_ICON_TCOORDS[class]; -- get the coordinates of the class icon we want
    arrayOfElements[i+1].icon:SetTexCoord(unpack(coords)); -- cut out the region with our class icon according to coords
    arrayOfElements[i+1].icon2 = arrayOfElements[i+1]:CreateTexture(nil,"CENTER"); -- create texture as child of myframe
    arrayOfElements[i+1].icon2:SetAllPoints(arrayOfElements[i+1]);
    arrayOfElements[i+1]:SetScript("onclick",function(self)
        self.icon2:SetColorTexture(1,1,1,0.3)
        if LootFinder.class ~= 0 and LootFinder.class ~= self:GetID() then
            WeekFrame.ClassBtn[LootFinder.class].icon2:SetColorTexture(1,1,1,0)
        end
        for k,v in pairs(WeekFrame.SpecBtn) do
            v.icon2:SetColorTexture(1,1,1,0)
        end
        LootFinder.class = self:GetID()
        LootFinder.spec = 0
        -- hide/show specialization button
        for j = 1, #WeekFrame.SpecBtn do
            if LootFinder.class_spec[LootFinder.class][j] == nil then
                WeekFrame.SpecBtn[j]:Hide()
            else
                local specID = LootFinder.class_spec[LootFinder.class][j]
                local _, _, _, icon, _, _ = GetSpecializationInfoByID(specID)
                WeekFrame.SpecBtn[j].icon:SetTexture(icon)
                WeekFrame.SpecBtn[j]:Show()
            end
        end
    end)
    arrayOfElements[i+1]:Hide()
    tinsert(WeekFrame.ClassBtn,arrayOfElements[i+1])
end
for i = 1, 4 do
    arrayOfElements[i+13] = CreateFrame("button",nil,WeekFrame)
    arrayOfElements[i+13]:SetPoint("TOPLEFT",150+i*35,-85)
    arrayOfElements[i+13]:SetSize(35,35)
    arrayOfElements[i+13]:SetID(i)
    arrayOfElements[i+13].icon = arrayOfElements[i+13]:CreateTexture(nil,"BACKGROUND");
    arrayOfElements[i+13].icon:SetAllPoints(arrayOfElements[i+13])
    arrayOfElements[i+13].icon2 = arrayOfElements[i+13]:CreateTexture(nil,"CENTER"); -- create texture as child of myframe
    arrayOfElements[i+13].icon2:SetAllPoints(arrayOfElements[i+13]);
    tinsert(WeekFrame.SpecBtn,arrayOfElements[i+13])
    arrayOfElements[i+13]:SetScript("OnShow",function(self)
        if LootFinder.class == 0 then
            self:Hide()
            return
        end
    end)
    arrayOfElements[i+13]:SetScript("OnClick",function(self)
        self.icon2:SetColorTexture(1,1,1,0.3)
        for k,v in pairs(WeekFrame.SpecBtn) do
            if k ~= self:GetID() then
                v.icon2:SetColorTexture(1,1,1,0)
            end
        end
        LootFinder.spec = LootFinder.class_spec[LootFinder.class][self:GetID()]
    end)
end
--18
local icons = {133070,133292,135061,133771,132751,132616,132939,132511,134584,132535,135317,134959,801523,133441}
local slots = {0,1,2,3,4,5,6,7,8,9,10,11,12,13}
for i = 1, 14 do
    arrayOfElements[i+17] = CreateFrame("button",nil,WeekFrame)
    arrayOfElements[i+17]:SetPoint("TOPLEFT",-30+i*35,-145)
    arrayOfElements[i+17]:SetSize(35,35)
    arrayOfElements[i+17]:SetID(slots[i])
    arrayOfElements[i+17].icon = arrayOfElements[i+17]:CreateTexture(nil,"BACKGROUND");
    arrayOfElements[i+17].icon:SetAllPoints(arrayOfElements[i+17])
    arrayOfElements[i+17].icon:SetTexture(icons[i])
    arrayOfElements[i+17].icon2 = arrayOfElements[i+17]:CreateTexture(nil,"CENTER"); -- create texture as child of myframe
    arrayOfElements[i+17].icon2:SetAllPoints(arrayOfElements[i+17]);
    arrayOfElements[i+17]:Hide()
    arrayOfElements[i+17]:SetScript("OnClick",function(self)
        LootFinder.slot = self:GetID()
        self.icon2:SetColorTexture(1,1,1,0.3)
        for k,v in pairs(WeekFrame.SlotBtn) do
            if v:GetID() ~= self:GetID() then
                v.icon2:SetColorTexture(1,1,1,0)
            end
        end
    end)
    tinsert(WeekFrame.SlotBtn,arrayOfElements[i+17])
end
--236372
--27:15 27:20
arrayOfElements[35] = CreateFrame("button",nil,WeekFrame)
arrayOfElements[35]:SetPoint("TOPLEFT",-30+14*35,-110)
arrayOfElements[35]:SetSize(35,35)
arrayOfElements[35].icon = arrayOfElements[35]:CreateTexture(nil,"CENTER");
arrayOfElements[35].icon:SetAllPoints(arrayOfElements[35])
arrayOfElements[35].icon:SetTexture(236372)
arrayOfElements[35]:Hide()
arrayOfElements[35]:SetScript("OnClick",function(self)
    LootFinder.slot = 15
    for k,v in pairs(WeekFrame.SlotBtn) do
        v.icon2:SetColorTexture(1,1,1,0)
    end
end)
arrayOfElements[35]:SetScript("OnEnter",function(self)
    GameTooltip:Hide();
    GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
    GameTooltip:AddLine(L["removeslot"],1,1,1)
    GameTooltip:Show()
end)
arrayOfElements[35]:SetScript("OnLeave",function(self)
    GameTooltip:Hide();
end)
--32
arrayOfElements[32] = CreateFrame("Frame", "Stating1", WeekFrame, "UIDropDownMenuTemplate")
arrayOfElements[32]:SetPoint("TOPLEFT",10,-190)
UIDropDownMenu_SetWidth(arrayOfElements[32], 100)
UIDropDownMenu_Initialize(arrayOfElements[32], WeekFrame.WPDropDownDemo_Menu1)
UIDropDownMenu_SetText(arrayOfElements[32],OPTIONAL)
arrayOfElements[32]:Hide()

arrayOfElements[33] = CreateFrame("Frame", "Stating2", WeekFrame, "UIDropDownMenuTemplate")
arrayOfElements[33]:SetPoint("TOPLEFT",10,-220)
UIDropDownMenu_SetWidth(arrayOfElements[33], 100)
UIDropDownMenu_Initialize(arrayOfElements[33], WeekFrame.WPDropDownDemo_Menu2)
UIDropDownMenu_SetText(arrayOfElements[33],OPTIONAL)
arrayOfElements[33]:Hide()

arrayOfElements[34] = CreateFrame("Button",nil,WeekFrame,"UIPanelButtonTemplate")
arrayOfElements[34]:SetPoint("TOPLEFT",30,-260)
arrayOfElements[34]:SetSize(120,30)
arrayOfElements[34]:SetText(SEARCH)
arrayOfElements[34]:SetScript("OnClick",function()
    LootFinder:Find()
    for i = 1, #WeekFrame.LootBtn do
        if LootFinder.LootList[i] then
            WeekFrame.LootBtn[i]:Hide()
            WeekFrame.LootBtn[i]:Show()
        else
            WeekFrame.LootBtn[i]:Hide()
        end
    end

    for i = #WeekFrame.LootBtn + 1,#LootFinder.LootList do
        local lInfo = CreateFrame('button', 'frameName', arrayOfElements[1], 'InsetFrameTemplate2')
        lInfo:SetID(i)
        local texture = lInfo:CreateTexture('textureName', 'BACKGROUND')
        texture:SetPoint('TOPLEFT', 2, -2)
        texture:SetPoint('bottomright', -2, 2)
        texture:SetColorTexture(0.2, 0.2, 0.2, 1)
        lInfo:SetHighlightTexture(texture)
        lInfo:DisableDrawLayer("BORDER")
        lInfo:SetNormalFontObject('GameFontNormal')
        lInfo:SetSize(WeekFrame:GetWidth()-8, 20)
        lInfo:SetPoint("TOPLEFT",4,-(i-1)*20)

        lInfo.instance = lInfo:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        lInfo.instance:SetPoint("LEFT",5,0)
        lInfo.instance:SetText(LootFinder.LootList[i][1])

        local itemname = GetItemInfo(LootFinder.LootList[i][2])
        lInfo.item = lInfo:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        lInfo.item:SetPoint("LEFT",160,0)
        lInfo.item:SetText("|cffffffff"..itemname)

        lInfo:SetScript("OnShow",function(self)
            local id = self:GetID()
            if not LootFinder.LootList[id] then
                self:Hide()
            end
            self.instance:SetText(LootFinder.LootList[id][1])

            local itemName = GetItemInfo(LootFinder.LootList[id][2])
            self.item:SetText("|cffffffff"..itemName)
        end)

        lInfo:SetScript("OnEnter",function(self)
            GameTooltip:Hide();

           local pattern = "5:"..mythic_level[LootFinder.level]..":6652:1501:"..end_of_run_ilvl[LootFinder.level]..":6646"
           -- a:gsub("%d+:3524:%d+:%d+:%d+:","5:7206:6652:1501:5871:6646")
            GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
            GameTooltip:SetHyperlink(LootFinder.LootList[self:GetID()][2]:gsub("%d+:3524:%d+:%d+:%d+:",pattern))
            
            GameTooltip:Show()
        end)
        lInfo:SetScript("OnLeave",function(self)
            GameTooltip:Hide();
        end)
        tinsert(WeekFrame.LootBtn,lInfo)
    end
end)
arrayOfElements[34]:Hide()

arrayOfElements[36] = CreateFrame("EditBox",nil,WeekFrame,"InputBoxTemplate")
arrayOfElements[36]:SetAutoFocus(false)
arrayOfElements[36]:SetPoint("TOPLEFT",-30+12*35,-220)
arrayOfElements[36]:SetSize(50,20)
arrayOfElements[36]:SetNumber(15)
arrayOfElements[36]:ClearFocus()
arrayOfElements[36]:SetMaxLetters(2)
arrayOfElements[36]:SetNumeric(true)

arrayOfElements[36]:SetScript("OnEditFocusLost",function(self)
    LootFinder.level = max(self:GetNumber(), 2)
    C_EncounterJournal.SetPreviewMythicPlusLevel(LootFinder.level)
    self:ClearFocus()
end)

arrayOfElements[36]:SetScript("OnEnterPressed",function(self)
    self:ClearFocus()
end)

arrayOfElements[36]:SetScript("OnShow",function()
    C_EncounterJournal.SetPreviewMythicPlusLevel(LootFinder.level)
end)
arrayOfElements[36]:SetScript("OnHide",function()
    C_EncounterJournal.SetPreviewMythicPlusLevel(0)
end)

arrayOfElements[36]:Hide()

arrayOfElements[37] = WeekFrame:CreateFontString(nil , "BORDER", "GameFontNormal")
arrayOfElements[37]:SetPoint("TOPLEFT",-30+12*35,-200)
arrayOfElements[37]:SetText(GUILD_RECRUITMENT_LEVEL)
arrayOfElements[37]:Hide()

local iIndex = 1
EJ_SelectTier(LootFinder.expansion)
while EJ_GetInstanceByIndex(iIndex, false) ~= nil do
    LootFinder.instances[iIndex] = true
    local _, name, _, bgim, buttonImage1, loreImage, buttonImage2 = EJ_GetInstanceByIndex(iIndex, false)
    arrayOfElements[iIndex+37] = CreateFrame("button",nil,WeekFrame)
    arrayOfElements[iIndex+37].name = name
    arrayOfElements[iIndex+37]:SetPoint("TOPLEFT",160+((iIndex-1)%6)*35,-210-math.floor((iIndex-1)/6)*35)
    arrayOfElements[iIndex+37]:SetSize(35,35)
    arrayOfElements[iIndex+37]:SetID(iIndex)
    arrayOfElements[iIndex+37].icon = arrayOfElements[iIndex+37]:CreateTexture(nil,"BACKGROUND");
    arrayOfElements[iIndex+37].icon:SetAllPoints(arrayOfElements[iIndex+37])
    arrayOfElements[iIndex+37].icon:SetTexture(buttonImage2)
    arrayOfElements[iIndex+37].icon2 = arrayOfElements[iIndex+37]:CreateTexture(nil,"CENTER"); -- create texture as child of myframe
    arrayOfElements[iIndex+37].icon2:SetAllPoints(arrayOfElements[iIndex+37]);
    local btn = arrayOfElements[iIndex+37]
    btn.find = true
    function btn:enable(bool)
        if bool then
            LootFinder.instances[self:GetID()] = true
            self.icon2:SetColorTexture(0,0,0,0)
        else
            LootFinder.instances[self:GetID()] = false
            self.icon2:SetColorTexture(0,0,0,0.6)
        end
        self.find = bool
    end
    arrayOfElements[iIndex+37]:SetScript("OnClick",function(self)
        self:enable(not self.find)
    end)
    arrayOfElements[iIndex+37]:SetScript("OnEnter",function(self)
        GameTooltip:Hide();
        GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
        GameTooltip:AddLine(self.name)
        GameTooltip:Show()
    end)
    arrayOfElements[iIndex+37]:SetScript("OnLeave",function(self)
        GameTooltip:Hide();
    end)
    arrayOfElements[iIndex+37]:Hide()
    iIndex = iIndex + 1
end

WeekKeys.AddButton(L["lootfinder"],arrayOfElements)
end)

--]]